-- Cooldown Module

local width, height = 250, 22

local cdtimers = LibStub("LibCandyBar-3.0")

function SN:CoolDowns()

	SN.F.cooldowns = CreateFrame("Frame", "CDFrame", UIParent)
	cds = SN.F.cooldowns
	cds.bars = {}
	cds:SetPoint("CENTER", UIParent, "CENTER", 0, -200)
	cds:SetSize(width + 8, height + 8)
	cds:SetBackdrop({ 
				bgFile = SN.V.media.blankTex,
				edgeFile = SN.V.media.blankTex,
				tile = true,
				tileSize = 4,
				edgeSize = 4, 
				insets = { left = 4, right = 4, top = 4, bottom = 4 }
	})
	cds:SetBackdropColor(0.1, 0.1, 0.1, 0.4)
	cds:SetBackdropBorderColor(0.1, 0.1, 0.1, 1)
	--cds:SetScript("OnUpdate", function(self)
	--			if #self.bars > 1 then 
	--				cds:SetSize(width + 8, (height * #self.bars) + 8)
	--			else
	--				cds:SetSize(width + 8, height + 8)
	--			end
	--			--print(cds:GetSize())
	--end)
	cds:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	cds:SetScript("OnEvent", function(self,event, ...)
		SN:UpdateCooldown(self,event,unit, ...)
	end)
	cds:SetMovable(true)
	cds:EnableMouse(true)
	cds:SetScript("OnMouseDown", function(self, button)
		if button == "LeftButton" and not self.isMoving then
			self:StartMoving()
			self.isMoving = true
		end
	end)
	cds:SetScript("OnMouseUp", function(self, button)
		if button == "LeftButton" and self.isMoving then
			self:StopMovingOrSizing()
			self.isMoving = false
		end
	end)
end

function SN:UpdateCooldown(frame,event,unit, ...)
	
	if(event == "COMBAT_LOG_EVENT_UNFILTERED") then
		--print("I made it here COMBAT")
		local timestamp, type,_, sourceGUID, sourceName,_,_, destGUID, destName = select(1, ...)
		local spellId, spellName, spellSchool = select(12, ...)
		local index = 0
		for i, cooldown in pairs(SN.cooldowns) do
			if(type == cooldown['succ']) then
				print(type)
				print(spellId)
				if(spellId == cooldown['spellID']) then
					print("I made it here SPELL")
					if sourceGUID == UnitGUID("player") then
						print("I made it here PLAYER")
						print(cooldown)
						print(cooldown['spellID'])
						print(cooldown['name'])
						print(cooldown['CD'])
						SN:StartCD(frame, cooldown, sourceGUID, sourceName, spellName)
					end
				end
			end
		end
	end	
end

function SN:CreateBar(frame, cooldown, caster, guid)
	
	--Start the CD Timer
	local bar = cdtimers:New(SN.V.media.minTex, width, height)
	frame.bars[bar] = true
	local class, classFileName = UnitClass(caster)
	local color = { r = 0.0, g = 0.44, b = 0.87 } --RAID_CLASS_COLORS[classFileName]

	bar:SetIcon(select(3, GetSpellInfo(cooldown['spellID'])))
	bar:Set("SN:module", "SN")
	bar:Set("SN:anchor", frame)
	bar:Set("SN:key", caster)
	bar:SetParent(frame)
	bar:SetFrameStrata("MEDIUM")
	bar:SetColor( 0.0, 0.44, 0.87);	
	bar:SetDuration(cooldown['CD'])
	bar:SetClampedToScreen(true)
	local caster = strsplit("-", caster)
	bar:SetLabel(caster)
	bar:SetPoint("TOPLEFT",cds,"TOPLEFT", 4, -4)

	bar.candyBarLabel:SetJustifyH("LEFT")

	SN:SNCreateBG(bar)
	
	bar:Start()
	SN:RearrangeBars(bar:Get("SN:anchor"))

	return bar
end

function SN:CancelBars(frame)
    for k in pairs(frame.bars) do
        k:Stop()
    end
	 
	 SN:RearrangeBars(frame) 
end

function SN:StartCD(frame, cooldown, guid, caster, spell)
	if not (SN.curr[cooldown['spellID']][guid]) then
	   SN.curr[cooldown['spellID']][guid]=guid
	end
	print(cooldown)
	if(SN.profileDB.castannounce) then
		local name = select(1, GetSpellInfo(cooldown['spellID']))
		local cd = cooldown['CD'] / 60
		if GetNumGroupMembers() > 1 and IsInRaid() then
			SendChatMessage(caster.." Casts "..name.." "..cd.."Min".." CD" ,"RAID");
		else
			SendChatMessage(caster.." Casts "..name.." "..cd.."Min".." CD" ,"PARTY");
		end
	end
		
	local bar = SN:CreateBar(frame, cooldown, caster, guid)
	
	local args = {frame, cooldown, guid, caster, bar, spell}
	local handle = SN:ScheduleTimer("StopCD", cooldown['CD'],args)
	SN['handles'][guid] = SN['handles'][guid] or {}
	SN['handles'][guid][spell] = {args,handle,bar}
end


function SN:StopCD(args)
	SN.curr[args[2]['spellID']][args[3]] = nil;
	
	local a = args[5]:Get("SN:anchor")
	if a and a.bars and a.bars[args[5]] then
      a.bars[args[5]] = nil
		SN:RearrangeBars(a) 
	end
	
	if(SN.profileDB.cdannounce) then
		local name = select(1, GetSpellInfo(args[2]['spellID']))
		if GetNumGroupMembers() > 1 and IsInRaid() then
			SendChatMessage(args[6].."'s "..name.." CD UP" ,"RAID");
		else
			SendChatMessage(args[6].."'s "..name.." CD UP" ,"PARTY");
		end
	end
end

local function barSorter(a, b)
	return a.remaining < b.remaining and true or false
end

function SN:RearrangeBars(anchor)
	if not anchor then return end
    if not next(anchor.bars) then return end
    local frame = anchor
	print(frame:GetName())
	wipe(SN.tmp)
	
    for bar in pairs(anchor.bars) do
		SN.tmp[#SN.tmp + 1] = bar
	end
	
	if(#SN.tmp>1)then
		frame:SetHeight((22*#SN.tmp) + 8)
	else
		frame:SetHeight(22 + 8)
	end

	table.sort(SN.tmp, barSorter)
	local lastDownBar, lastUpBar = nil, nil
	
	for i, bar in next, SN.tmp, nil do
		local spacing = -6
		bar:ClearAllPoints()
		if not (lastDownBar) then
			bar:SetPoint("TOPLEFT",anchor,"TOPLEFT", 4, -4)
		else    
    		bar:SetPoint("TOPLEFT", lastDownBar, "BOTTOMLEFT", 0, 0)
		end
		lastDownBar = bar
	end
end
